//------------------------------------------------------------------------------
// libViewer Pro Package Extension
// Server for Dublin Core Library Files
//------------------------------------------------------------------------------
package Server1to1;

import java.net.*;
import java.io.*;
import java.util.*;

public class ServerMulti1to1 extends Thread {

  private Socket socket = null;

  static boolean Lib_loaded = false;

  public ServerMulti1to1 (Socket socket) {

    super("ServerMulti1to1");
	  this.socket = socket;

  }

  public void run () {

    BufferedReader in = null;
    PrintWriter   out = null;
    String inputLine = "";
    String outputLine = "";

        try {
            out = new PrintWriter(socket.getOutputStream(), true);
        } catch (IOException e) {
            System.err.println("Cannot open PrintWriter.");
            }

        try {
        in = new BufferedReader(
				new InputStreamReader(
				socket.getInputStream()));
        } catch (IOException e) {
            System.err.println("Cannot open BufferedReader.");
            }

        System.out.println("Server1to1 V0.1 is processing a client request...");

        try {

              inputLine = in.readLine();

            } catch (IOException e) {
            System.err.println("IO-Exception/maybe Connection lost.");
            }

        if (Settings.ERROR_DETAILS_ON) System.out.println(inputLine);
        // switch function code
        if (inputLine.compareTo("$SERV_BUT " + Settings.FUNC_1) == 0) LoadLibrary(in, out);
        else {
              sendIllegalItemMessage(out, inputLine);
              System.out.println("ERROR: Illegal Keyword received: " + inputLine);
              // die Argumente $DATA und $RESERVED von der in-queue lesen
              try { inputLine = in.readLine(); inputLine = in.readLine();
                  } catch (IOException e) {
                  System.err.println("IO-Exception/maybe Connection lost.");
              }
              
     }

     try { out.close(); } catch (Exception e) { System.out.println("Close OUT-Channel failed.");}
     try { in.close(); } catch (Exception e) { System.out.println("Close IN-Channel failed.");}
     try { socket.close(); } catch (Exception e) { System.out.println("Close client socket failed.");}

}
//------------------------------------------------------------------------------
  public static void LoadLibrary (BufferedReader in, PrintWriter out) {

        URL webpage = null;
        String inputLine = "";
        String filename = "";
        String word  = "";
        BufferedReader AV_in = null;
        int i = 0;
        int start_position = 0;
        int counter = 1;
        boolean K = true;
        boolean filemode = false;

        // read filename from Client
        try {

              inputLine = in.readLine();
              if (inputLine.indexOf("$SERV_DATA") != -1) inputLine = inputLine.substring(11);
              else System.out.println("Illegal Field received for $DATA");

            } catch (IOException e) {
            System.err.println("IO-Exception/maybe Connection lost.");
        }

        filename = inputLine;
        // read reserved data from Client and do nothing
        try {

              inputLine = in.readLine();

            } catch (IOException e) {
            System.err.println("IO-Exception/maybe Connection lost.");
        }

        if (Settings.ERROR_DETAILS_ON) System.out.println("daten empfangen. lade lib");
        try { webpage = new URL(filename);
        } catch (MalformedURLException mue) { filemode = true; }

        // read Library
        ItemList itemlist = new ItemList();
        Map map = new Map();

        if (filemode) FileReader.readLibrary(false, itemlist, map, filename);
        else FileReader.readLibrary(true, itemlist, map, filename);

        if (map.valid) {
            out.println("$SHELVE_ROWS " + map.y_dim);
            out.println("$SHELVE_COLUMNS " + map.x_dim);
            int m,n;
            for (n = 0; n < map.y_dim; n++) {
              for (m = 0; m < map.x_dim; m++) {
                out.println("$SHELVE_LABEL " + map.labels[m][n]);
                out.println("$SHELVE_DESCR " + map.descr[m][n]);
              }
            }
        }
        if (Lib_loaded) {
          // convert Items and send them back to libViewer
          if (Settings.ERROR_DETAILS_ON) System.out.println("lib erfolgreich geladen, sende daten zurueck");

          out.println("$ITEMCOUNT " + itemlist.number_items);
          out.println("$STATUS_CODE 0");
          out.println("$STATUS_TXT Server1to1: done.");

          if (Settings.SEND_ACTION_BACK) sendAction(out);

          for (i = 0; i < itemlist.number_items; i++) {

             out.println("$TITLE " + itemlist.items[i].title);
             if (itemlist.items[i].width.compareTo("") != 0) out.println("$WIDTH " + itemlist.items[i].width);
             if (itemlist.items[i].height.compareTo("") != 0) out.println("$HEIGHT " + itemlist.items[i].height);
             if (itemlist.items[i].creator.compareTo("") != 0) out.println("$CREATOR " + itemlist.items[i].creator);
             if (itemlist.items[i].subject.compareTo("") != 0) out.println("$SUBJECT " + itemlist.items[i].subject);
             if (itemlist.items[i].description.compareTo("") != 0) out.println("$DESCRIPTION " + itemlist.items[i].description);
             if (itemlist.items[i].publisher.compareTo("") != 0) out.println("$PUBLISHER " + itemlist.items[i].publisher);
             if (itemlist.items[i].contributor.compareTo("") != 0) out.println("$CONTRIBUTOR " + itemlist.items[i].contributor);
             if (itemlist.items[i].date.compareTo("") != 0) out.println("$DATE " + itemlist.items[i].date);
             if (itemlist.items[i].type.compareTo("") != 0) out.println("$TYPE " + itemlist.items[i].type);
             if (itemlist.items[i].format.compareTo("") != 0) out.println("$FORMAT " + itemlist.items[i].format);
             if (itemlist.items[i].identifier.compareTo("") != 0) out.println("$IDENTIFIER " + itemlist.items[i].identifier);
             if (itemlist.items[i].source.compareTo("") != 0) out.println("$SOURCE " + itemlist.items[i].source);
             if (itemlist.items[i].language.compareTo("") != 0) out.println("$LANGUAGE " + itemlist.items[i].language);
             if (itemlist.items[i].relation.compareTo("") != 0) out.println("$RELATION " + itemlist.items[i].relation);
             if (itemlist.items[i].coverage.compareTo("") != 0) out.println("$COVERAGE " + itemlist.items[i].coverage);
             if (itemlist.items[i].rights.compareTo("") != 0) out.println("$RIGHTS " + itemlist.items[i].rights);
             if (itemlist.items[i].domain.compareTo("") != 0) out.println("$DOMAIN " + itemlist.items[i].domain);
             if (itemlist.items[i].size_page.compareTo("") != 0) out.println("$SIZE_PAGE " + itemlist.items[i].size_page);
             if (itemlist.items[i].size_byte.compareTo("") != 0) out.println("$SIZE_BYTE " + itemlist.items[i].size_byte);
             if (itemlist.items[i].image_logo.compareTo("") != 0) out.println("$IMAGE_LOGO " + itemlist.items[i].image_logo);
             if (itemlist.items[i].template.compareTo("") != 0) out.println("$TEMPLATE " + itemlist.items[i].template);
             if (itemlist.items[i].image_wellthumbed.compareTo("") != 0) out.println("$IMAGE_WELLTHUMBED " + itemlist.items[i].image_wellthumbed);
             if (itemlist.items[i].dust_level.compareTo("") != 0) out.println("$DUST_LEVEL " + itemlist.items[i].dust_level);
             if (itemlist.items[i].color_front.compareTo("") != 0) out.println("$COLOR_FRONT " + itemlist.items[i].color_front);
             if (itemlist.items[i].color_top.compareTo("") != 0)out.println("$COLOR_TOP " + itemlist.items[i].color_top);
             if (itemlist.items[i].color_spine.compareTo("") != 0)out.println("$COLOR_SPINE " + itemlist.items[i].color_spine);
             if (itemlist.items[i].color_title.compareTo("") != 0)out.println("$COLOR_TITLE " + itemlist.items[i].color_title);
             if (itemlist.items[i].color_creator.compareTo("") != 0)out.println("$COLOR_CREATOR " + itemlist.items[i].color_creator);
             if (itemlist.items[i].highlighting.compareTo("") != 0)out.println("$HIGHLIGHTING " + itemlist.items[i].highlighting);
             if (itemlist.items[i].xpos.compareTo("") != 0) out.println("$XPOS " + itemlist.items[i].xpos);
             if (itemlist.items[i].ypos.compareTo("") != 0) out.println("$YPOS " + itemlist.items[i].ypos);
             if (itemlist.items[i].zpos.compareTo("") != 0) out.println("$ZPOS " + itemlist.items[i].zpos);
           }
        }
        else {
          out.println("$STATUS_CODE 3");
          out.println("$STATUS_TXT Server1to1: I/O Error! File: " + filename);
        }
        System.out.println("Request processed. waiting for requests...");

  }

//------------------------------------------------------------------------------
static public void sendIllegalItemMessage (PrintWriter out, String arg) {
    out.println("$STATUS_CODE 3");
    out.println("$STATUS_TXT Server1to1: unknown function code: " + arg);
}
//------------------------------------------------------------------------------
static public void sendAction (PrintWriter out) {
   out.println("$SERV_URL " + Settings.SERVER_URL);
   out.println("$SERV_PORT " + Settings.SERVER_PORT);
   out.println("$SERV_DESCR " + Settings.SERVER_DESCR);
   if (Settings.SERVER_DATA.compareTo("") != 0) out.println("$SERV_DATA " + Settings.SERVER_DATA);
   out.println("$SERV_BUT1 " + Settings.SERVER_BUT1);
   if (Settings.SERVER_BUT2.compareTo("") != 0) out.println("$SERV_BUT2 " + Settings.SERVER_BUT2);
   out.println("$SERV_BUT1TXT " + Settings.SERVER_BUT1TXT);
   if (Settings.SERVER_BUT2TXT.compareTo("") != 0) out.println("$SERV_BUT2TXT " + Settings.SERVER_BUT2TXT);
   if (Settings.SERVER_RESERVED.compareTo("") != 0) out.println("$SERV_RESERVED " + Settings.SERVER_RESERVED);
}
//------------------------------------------------------------------------------

} 

